﻿namespace BrushUpTeacherValidatorUnitTest
{
    public class Teacher
    {
        public int Id { get; set; }
        public string Name { get; set; }
        public int Salary { get; set; }

        public Teacher(int id, string name, int salary)
        {
            Id = id;
            Name = name;
            Salary = salary;
        }

        public Teacher()
        {
        }

        public void ValidateName()
        {
           // if (String.IsNullOrEmpty(Name)) throw new ArgumentException("Name is null or empty");

            if (Name == null) throw new ArgumentNullException("name is null");

            if (Name.Length < 1) throw new ArgumentException("name must be at least 1 character: " + Name);

        }

        public void ValidateSalary()
        {
            if (Salary < 0) throw new ArgumentOutOfRangeException("Salery must be positive: " + Salary);
        }

        public void Validate()
        {
            ValidateName();
            ValidateSalary();
        }


        public override string ToString()
        {
            return $"{{{nameof(Id)}={Id.ToString()}, {nameof(Name)}={Name}, {nameof(Salary)}={Salary.ToString()}}}";
        }
    }
}